//
//  FolderItem.swift
//  Browse
//
//  Created by Javier Cicchelli on 02/12/2022.
//  Copyright © 2022 Röck+Cöde. All rights reserved.
//

import SwiftUI

struct FolderItem: View {
    
    // MARK: Properties
    
    let name: String

    // MARK: Body

    var body: some View {
        HStack(spacing: 16) {
            Image.folder
                .icon(size: 32)
                .foregroundColor(.red)
            
            Text(name)
                .itemName()
            
            Image.chevronRight
                .icon(size: 16)
                .foregroundColor(.secondary)
                .font(.headline)
        }
        .padding(.vertical, 8)
    }

}

// MARK: - Image+Constants

private extension Image {
    static let folder = Image(systemName: "folder.fill")
    static let chevronRight = Image(systemName: "chevron.right")
}

// MARK: - Previews

struct BrowseItem_Previews: PreviewProvider {
    static var previews: some View {
        FolderItem(name: "Some folder name goes in here...")
            .previewDisplayName("Folder item")
        
        FolderItem(name: "Some very, extremely long folder name goes in here...")
            .previewDisplayName("Folder item with long name")
    }
}
